from mira.module import BaseModule

NAME = 'test'

class TestModule(BaseModule):
    __instance = None

    @staticmethod
    def get_instance(base, config):
        if TestModule.__instance == None:
            TestModule(base, config)

        return TestModule.__instance
    
    def __init__(self, base, config):
        if TestModule.__instance != None:
            raise Exception('Trying to init singleton twice')

        super().__init__(base, config)
        TestModule.__instance = self

    def on_command(self, cmd, msg):
        greeting = self.get_option('greeting', 'OwO, %%user%%!').replace('%%user%%', str(msg.from_.bare()))
        self._base.send_message_wrapper(msg.from_, greeting)

def get_instance(base, config={}):
    return TestModule.get_instance(base, config)
